//variabile primul driver ptr motoare
int ok = 1;
const int in1 = 9;
const int in2 = 10;
const int in3 = 11;
const int in4 = 12;
//al doilea driver ptr motoare
const int in5 = 5;
const int in6 = 6;
const int in7 = 7;
const int in8 = 8;
//senzor de gaz mq2
const int mqTwoPin = A0, buzzerPin = 13;
//senzor gaz mq4
const int mqFourPin = A1;
//senzor de gaz mq9
const int mqNinePin = A2;
//senzor de foc
const int flameSensorPin = 2;
//senzor ultrasonic
const int triggerPin = A5, echoPin = 4;

void setup()
{
  //setup ptr driverele motoarelor
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);
  pinMode(in5, OUTPUT);
  pinMode(in6, OUTPUT);
  pinMode(in7, OUTPUT);
  pinMode(in8, OUTPUT);
  //setup ptr senzorul ultrasonic
  Serial.begin(9600);
  pinMode(triggerPin, OUTPUT);
  pinMode(echoPin, INPUT);
  analogWrite(triggerPin, 0);
  //setup pentru detectare flacara
  pinMode(flameSensorPin, INPUT);
  pinMode(buzzerPin, OUTPUT);
  digitalWrite(buzzerPin, LOW);
  //setup ptr detectare gaze toxice mq2
  pinMode(mqTwoPin, INPUT);
  //setup ptr detectare gaze toxice mq4
  pinMode(mqFourPin, INPUT);
  //setup ptr detectare gaze toxice mq9
  pinMode(mqNinePin, INPUT);
  
}
//functie ptr a calcula distanta pana la obstacol cu ajutorul
//senzorului ultrasonic distanta fiind calculata prin produsul
//dintre viteza sunetului si durata pana cand sunetul se intoarce
double computeDistance(int trigger, int echo, double soundSpeed) {
  analogWrite(trigger, 255);
  delayMicroseconds(10);
  analogWrite(trigger, 0);
  unsigned long duration = pulseIn(echo, HIGH) / 2;
  return duration * soundSpeed;
}
//functia care ne porneste driverele motoarelor si seteaza toti pinii pe
//high pentru ca toate rotile sa traga in aceeasi directie
//primii 4 pini sunt cei care comanda rotile din fata 
//ceilalti ptr rotile din spate
void carMoving()
{

  digitalWrite(in1, HIGH);
  digitalWrite(in2, LOW);
  digitalWrite(in3, HIGH);
  digitalWrite(in4, LOW);

  digitalWrite(in5, HIGH);
  digitalWrite(in6, LOW);
  digitalWrite(in7, HIGH);
  digitalWrite(in8, LOW);

}

void carStop()
{
  digitalWrite(in1, LOW);
  digitalWrite(in2, LOW);
  digitalWrite(in3, LOW);
  digitalWrite(in4, LOW);

  digitalWrite(in5, LOW);
  digitalWrite(in6, LOW);
  digitalWrite(in7, LOW);
  digitalWrite(in8, LOW);
}
//functie ptr senzorul de foc 
void makeNoise(int buzzerPin, int buzzTime) {
  digitalWrite(buzzerPin, HIGH);
  delay(buzzTime);
  digitalWrite(buzzerPin, LOW);
}

void loop()
{
  ok = 1;
  digitalWrite(buzzerPin, LOW);
  carMoving();
  
  //ptr senzorul de gaz mq4
  if(analogRead(mqFourPin) > 700 || analogRead(mqTwoPin) > 700 || analogRead(mqNinePin) >  700){
    ok = 0;
  } 
  
  //ptr senzorul de foc
  if (digitalRead(flameSensorPin) == LOW) {
    ok = 0;
  }
 
  if(ok == 1)
  {
   if(computeDistance(triggerPin, echoPin, 0.0343) > 10) 
   {
     carMoving();
   }
   else
   {
    carStop();
   }
  }
  else
  {
    carStop();
    makeNoise(buzzerPin, 1000);
  }
}
